ASK: Adaptive Sampling Kit
==========================

Adaptive Sampling Kit (ASK) is a toolkit for sampling big experimental spaces. It features multiple active learning algorithms 
to prioritize the exploration of the interesting parts of the experimental space. 

Documentation
=============

ASK user manual is available at the following URL
 
https://github.com/benchmark-subsetting/adaptive-sampling-kit/wiki/Chapter-1:-Introduction

Licence
=======

Copyright (c) 2011-2015, Université de Versailles St-Quentin-en-Yvelines and Contributors
ASK is released under the GNU General Public License, version 2. Please refer to LICENSE, for details.

Contact
=======

For any question regarding ASK, please write to the adaptive sampling kit mailing list at 
[adaptive-sampling-kit@googlegroups.com](mailto:adaptive-sampling-kit@googlegroups.com).

For bug reports, features requests or contributions please use the [project
tracker](https://github.com/benchmark-subsetting/adaptive-sampling-kit).

ASK: Adaptive Sampling Kit
==========================

Adaptive Sampling Kit (ASK) is a toolkit for sampling big experimental spaces. It features multiple active learning algorithms 
to prioritize the exploration of the interesting parts of the experimental space. 

Documentation and Installation
==============================

The documentation and installation procedures are detailed at
http://code.google.com/p/adaptive-sampling-kit/wiki/main

Licence
=======

Copyright (c) 2011-2012, Université de Versailles St-Quentin-en-Yvelines
ASK is released under the GNU General Public License, version 2. Please refer to LICENSE, for details.

Contact
=======

For any question regarding ASK, please write at <ask-team@exascale-computing.eu>.

Contributors
============

Pablo de Oliveira Castro, wrote ASK and its documentation
Eric Petit contributed many ideas during ASK development and evaluated ASK on two performance case-studies
Asma Farjallah helped test ASK on a Reverse Time Migration kernel
E. Beyler, J.C. Beyler, and B. Krammer, reviewed extensively this documentation
J.C. Beyler, M. Bordet, Y. Kashnikov, J. Noudohouenou, B. Pradelle, F. Talbart, and N. Triquenaux provided useful code reviews

Acknowledgments
===============

This software is a result of work performed in Exascale Computing
Research Center with support provided by CEA, GENCI, Intel, and
UVSQ.

This set of scripts are used to automatically update the wiki documentation
at https://code.google.com/p/adaptive-sampling-kit/wiki/main.

They transform the latex documentation into a set of google wiki formated pages.
Dependencies for running these scripts:
 * Python 3 (deals properly with utf8)
 * pandoc (http://johnmacfarlane.net/pandoc/)
 * markowik (https://pypi.python.org/pypi/markowik)

#!/usr/bin/env Rscript
# Copyright (c) 2011-2012, Universite de Versailles St-Quentin-en-Yvelines
#
# This file is part of ASK.  ASK is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


args <- commandArgs(trailingOnly = T)

if (length(args) != 6) {
    stop("Usage: 1D.R <configuration> <test_set> <predicted> <labelled> <newly_labelled> <output.png>")
}

source(file.path(Sys.getenv("ASKHOME"), "common/configuration.R"))
require(rjson, quietly=T)


testset = read.table(args[2])
predicted = read.table(args[3])
labelled = read.table(args[4])
newlylabelled = read.table(args[5])
outputpng = args[6]

D = data.frame(X=testset$V1,
               E=abs(testset$V2-predicted$V2),
               P=predicted$V2)

png(file=outputpng)
plot(testset$V1, testset$V2, t="l", col="white", xlab="factor", ylab="response")
hierarchical_dump = file.path(conf("output_directory"), "hierarchical.dump")
if (file.exists(hierarchical_dump)) {
    hierarchical = read.table(hierarchical_dump, header=T)

    for (i in 1:nrow(hierarchical)) {
        p = hierarchical[i,]

        p$vu = p$mean+p$variance
        p$vl = p$mean-p$variance
        p$mu = p$mean+p$ub
        p$ml = p$mean-p$ub

        rect(p$mi,p$ml,p$ma,p$mu, border=NA, col="wheat")
        rect(p$mi,p$vl,p$ma,p$vu, border=NA, col="seashell")
    }
}

lines(testset$V1, testset$V2, t="l")

rug(labelled$V1)
#lines(predicted$V1, predicted$V2, t="l", col="green")
lab = labelled[1:(nrow(labelled)-nrow(newlylabelled)),] 
points(lab$V1, lab$V2)
points(newlylabelled$V1, newlylabelled$V2,col="red", pch=4)
legend("topleft", c("samples", "last iteration samples"), col=c("black", "red"), pch=c(1,4))


# write time series statistics
stats_out = conf("modules.reporter.params.timeseries", "")
if (stats_out != "") {
    card = nrow(labelled)
    res = testset$V2 - predicted$V2
    mean_err = mean(abs(res))
    max_err = max(abs(res))
    rmse_err = sqrt(mean(res*res))
    per_err = mean(abs(res)/testset$V2*100)
    max_per_err = max(abs(res)/testset$V2*100)
    sf = file(stats_out, "a")
    writeLines(paste(card, mean_err, max_err, rmse_err, per_err, max_per_err),con=sf,sep="\n")
    close(sf)
}

#!/usr/bin/env Rscript
# Copyright (c) 2011-2012, Universite de Versailles St-Quentin-en-Yvelines
#
# This file is part of ASK.  ASK is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


packages = c("gbm", "rpart", "lattice", "RJSONIO", "lhs", "tgp", "fOptions", "inline")

new.repos <- getOption("repos")
new.repos["CRAN"] <- "http://cran.stat.ucla.edu"
options(repos = new.repos)

for (p in packages) {
  # if the package is not installed or old, install/upgrade it
  if ((!(p %in% installed.packages())) | (p %in% old.packages())) {
    install.packages(p)
  }
}

#!/usr/bin/env Rscript
# Wrapper around the ci.cv.R: code from the MBESS 3.3.3 package
# at http://cran.r-project.org/web/packages/MBESS/
# Authored and Maintained by Ken Kelley and Keke Lai<LaiKeke at ASU.edu>
#
# Copyright (c) 2012 Ken Kelley and Keke Lai
#
# This file is part of MBESS.  MBESS is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

ci.cv <- function (cv = NULL, mean = NULL, sd = NULL, n = NULL, data = NULL,
          conf.level = 0.95, alpha.lower = NULL, alpha.upper = NULL,
          ...)
{
  if (is.null(conf.level)) {
    if (alpha.lower >= 1 | alpha.lower < 0)
      stop("'alpha.lower' is not correctly specified.")
    if (alpha.upper >= 1 | alpha.upper < 0)
      stop("'alpha.upper' is not correctly specified.")
  }
  if (!is.null(conf.level)) {
    if (!is.null(alpha.lower) | !is.null(alpha.upper))
      stop("Since 'conf.level' is specified, 'alpha.lower' and 'alpha.upper' should be 'NULL'.")
    alpha.lower <- (1 - conf.level)/2
    alpha.upper <- (1 - conf.level)/2
  }
  if (is.null(data) & is.null(cv)) {
    if (is.null(mean))
      stop("Either input the whole data set using 'data' or specify the sample mean.")
    if (mean <= 0)
      stop("The sample mean must be some non-zero positive value (Does taking the absolute value of the mean make sense?).")
    if (is.null(sd))
      stop("Either input the whole data set using 'data' or specify the sample standard deviation (using 'n'-1 in the denominator).")
    if (is.null(n))
      stop("Either input the whole data set using 'data' or specify the sample size")
    k <- sd/mean
    ncp.estimate <- sqrt(n)/k
    CI.NCP <- conf.limits.nct(ncp = ncp.estimate, df = n -
      1, alpha.lower = alpha.upper, alpha.upper = alpha.lower,
                              conf.level = NULL)
    Low.lim <- CI.NCP$Upper.Limit
    Up.lim <- CI.NCP$Lower.Limit
    Low.Lim <- sqrt(n)/Low.lim
    Up.Lim <- sqrt(n)/Up.lim
    if (Up.lim <= 0)
      Up.Lim <- Inf
    Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                   Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                   C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.lower == 0)
      Result <- list(Lower.Limit.CofV = -Inf, Prob.Less.Lower = 0,
                     Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.upper == 0)
      Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                     Upper.Limit.CofV = Inf, Prob.Greater.Upper = 0,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (Up.Lim == Inf)
      Result[4] <- 0
    if (round((Result$Prob.Less.Lower + Result$Prob.Greater.Upper),
ci.cv <- function (cv = NULL, mean = NULL, sd = NULL, n = NULL, data = NULL,
          conf.level = 0.95, alpha.lower = NULL, alpha.upper = NULL,
          ...)
{
  if (is.null(conf.level)) {
    if (alpha.lower >= 1 | alpha.lower < 0)
      stop("'alpha.lower' is not correctly specified.")
    if (alpha.upper >= 1 | alpha.upper < 0)
      stop("'alpha.upper' is not correctly specified.")
  }
  if (!is.null(conf.level)) {
    if (!is.null(alpha.lower) | !is.null(alpha.upper))
      stop("Since 'conf.level' is specified, 'alpha.lower' and 'alpha.upper' should be 'NULL'.")
    alpha.lower <- (1 - conf.level)/2
    alpha.upper <- (1 - conf.level)/2
  }
  if (is.null(data) & is.null(cv)) {
    if (is.null(mean))
      stop("Either input the whole data set using 'data' or specify the sample mean.")
    if (mean <= 0)
      stop("The sample mean must be some non-zero positive value (Does taking the absolute value of the mean make sense?).")
    if (is.null(sd))
      stop("Either input the whole data set using 'data' or specify the sample standard deviation (using 'n'-1 in the denominator).")
    if (is.null(n))
      stop("Either input the whole data set using 'data' or specify the sample size")
    k <- sd/mean
    ncp.estimate <- sqrt(n)/k
    CI.NCP <- conf.limits.nct(ncp = ncp.estimate, df = n -
      1, alpha.lower = alpha.upper, alpha.upper = alpha.lower,
                              conf.level = NULL)
    Low.lim <- CI.NCP$Upper.Limit
    Up.lim <- CI.NCP$Lower.Limit
    Low.Lim <- sqrt(n)/Low.lim
    Up.Lim <- sqrt(n)/Up.lim
    if (Up.lim <= 0)
      Up.Lim <- Inf
    Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                   Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                   C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.lower == 0)
      Result <- list(Lower.Limit.CofV = -Inf, Prob.Less.Lower = 0,
                     Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.upper == 0)
      Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                     Upper.Limit.CofV = Inf, Prob.Greater.Upper = 0,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (Up.Lim == Inf)
      Result[4] <- 0
    if (round((Result$Prob.Less.Lower + Result$Prob.Greater.Upper),
              3) != round((alpha.lower + alpha.upper), 3))
      warning("The computed confidence interval does not have the same coverage as the specified confidence interval.",
              call. = FALSE)
    return(Result)
  }
  if (!is.null(data) & is.null(cv)) {
    if (!is.null(mean))
      stop("Since 'data' is specified, do not specify the 'mean'.")
    if (!is.null(sd))
      stop("Since 'data' is specified, do not specify the 'sd'.")
    if (!is.null(n))
      stop("Since 'data' is specified, do not specify the 'n'.")
    n <- length(data)
    sd.data <- (var(data))^0.5
    mean.data <- mean(data)
    k <- sd.data/mean.data
    ncp.estimate <- sqrt(n)/k
    CI.NCP <- conf.limits.nct(ncp = ncp.estimate, df = n -
      1, alpha.lower = alpha.upper, alpha.upper = alpha.lower,
                              conf.level = NULL)
    Low.lim <- CI.NCP$Upper.Limit
    Up.lim <- CI.NCP$Lower.Limit
    Low.Lim <- sqrt(n)/Low.lim
    Up.Lim <- sqrt(n)/Up.lim
    if (Up.lim <= 0)
      Up.Lim <- Inf
    Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                   Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                   C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.lower == 0)
      Result <- list(Lower.Limit.CofV = -Inf, Prob.Less.Lower = 0,
                     Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.upper == 0)
      Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                     Upper.Limit.CofV = Inf, Prob.Greater.Upper = 0,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (Up.Lim == Inf)
      Result[4] <- 0
    if (round((Result$Prob.Less.Lower + Result$Prob.Greater.Upper),
              3) != round((alpha.lower + alpha.upper), 3))
      warning("The computed confidence interval does not have the same coverage as the specified confidence interval.",
              call. = FALSE)
    return(Result)
  }
  if (!is.null(cv)) {
    k <- cv
    if (is.null(n))
      stop("Since you specified the coefficient of variation directly ('cv'), you must specify the sample size.")
    if (!is.null(data))
      stop("Since you specified the coefficient of variation ('cv') directly, do not include the raw data.")
    if (!is.null(mean))
      stop("Since you specified the coefficient of variation ('cv') directly, do not specify the mean ('mean').")
    if (!is.null(sd))
      stop("Since you specified the coefficient of variation ('cv') directly, do not specify the standard deviation ('sd').")
    ncp.estimate <- sqrt(n)/k
    CI.NCP <- conf.limits.nct(ncp = ncp.estimate, df = n -
      1, alpha.lower = alpha.upper, alpha.upper = alpha.lower,
                              conf.level = NULL)
    Low.lim <- CI.NCP$Upper.Limit
    Up.lim <- CI.NCP$Lower.Limit
    Low.Lim <- sqrt(n)/Low.lim
    Up.Lim <- sqrt(n)/Up.lim
    if (Up.lim <= 0)
      Up.Lim <- Inf
    Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                   Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                   C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.lower == 0)
      Result <- list(Lower.Limit.CofV = -Inf, Prob.Less.Lower = 0,
                     Upper.Limit.CofV = Up.Lim, Prob.Greater.Upper = alpha.upper,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (alpha.upper == 0)
      Result <- list(Lower.Limit.CofV = Low.Lim, Prob.Less.Lower = alpha.lower,
                     Upper.Limit.CofV = Inf, Prob.Greater.Upper = 0,
                     C.of.V = k, C.of.V.Unbiased=k*(1+1/(4*n)))
    if (Up.Lim == Inf)
      Result[4] <- 0
    if (round((Result$Prob.Less.Lower + Result$Prob.Greater.Upper),
              3) != round((alpha.lower + alpha.upper), 3))
      warning("The computed confidence interval does not have the same coverage as the specified confidence interval.",
              call. = FALSE)
    return(Result)
  }
}

# This module computes the coefficient of variation upper bound
# Parse the arguments
args <- commandArgs(trailingOnly = T)
if (length(args) != 4) {
    stop("Usage: coef-variation mean sd sample-size alpha")
}

i_mean=as.real(args[1])
i_sd=as.real(args[2])
i_n=as.integer(args[3])
i_alpha=as.real(args[4])

print(ci.cv(mean=i_mean,sd=i_sd,n=i_n,conf.level=i_alpha)$Upper.Limit.CofV)

#!/usr/bin/env Rscript
# Copyright (c) 2011-2012, Universite de Versailles St-Quentin-en-Yvelines
#
# This file is part of ASK.  ASK is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


args <- commandArgs(trailingOnly = T)

if (length(args) != 6) {
    stop("Usage: 2D.R <configuration> <test_set> <predicted> <labelled> <newly_labelled> <output.png>")
}

source(file.path(Sys.getenv("ASKHOME"), "common/configuration.R"))
testset = read.table(args[2])
predicted = read.table(args[3])
labelled = read.table(args[4])
newlylabelled = read.table(args[5])
outputpng = args[6]

D = data.frame(X=testset$V1,Y=testset$V2,
               E=abs(testset$V3-predicted$V3),
               P=predicted$V3)

suppressPackageStartupMessages(require(graphics, quietly=T))
suppressPackageStartupMessages(require(lattice, quietly=T))
png(file=outputpng, width=1000, height=1200)

ep = levelplot(D$E ~ D$X*D$Y, cuts=31,
        colorkey=list(col=rev(heat.colors(32))),
        col.regions=rev(heat.colors(32)),
        at=seq(from=0,to=conf("modules.reporter.params.max_error_scale",
                              max(D$E))
          ,length=32),
        xlab="X",
        ylab="Y     (Absolute Error)",
        panel=function(...){
            panel.levelplot(...)
            lpoints(labelled$V1, labelled$V2, pch=1, col=1, cex=1)
            lpoints(newlylabelled$V1, newlylabelled$V2, pch=1, col=2, cex=1)
        }
        )


pp = levelplot(D$P ~ D$X*D$Y, cuts=31,
        colorkey=list(col=rev(heat.colors(32))),
        col.regions=rev(heat.colors(32)), xlab="X",
        ylab="Y     (Prediction)",
        panel=function(...){
            panel.levelplot(...)
            lpoints(labelled$V1, labelled$V2, pch=1, col=1, cex=1)
            lpoints(newlylabelled$V1, newlylabelled$V2, pch=1, col=2, cex=1)
        }
        )

print(ep, split=c(1,1,1,2), more=TRUE)
print(pp, split=c(1,2,1,2), more=TRUE)


# write time series statistics
stats_out = conf("modules.reporter.params.timeseries", "")
if (stats_out != "") {
    card = nrow(labelled)
    res = D$E
    mean_err = mean(abs(res))
    max_err = max(abs(res))
    rmse_err = sqrt(mean(res*res))
    per_err = mean(abs(res)/testset$V3*100)
    max_per_err = max(abs(res)/testset$V3*100)
    sf = file(stats_out, "a")
    writeLines(paste(card, mean_err, max_err, rmse_err, per_err, max_per_err),con=sf,sep="\n")
    close(sf)
}

#!/usr/bin/env Rscript

args <- commandArgs(trailingOnly = T)
if (length(args) != 3) {
    stop("Usage: source <configuration.conf> <requested_file> <output_file>")
}

# Read the requested points
requested = read.table(args[2])

# Define the function we are studying
# (in a real experiment here we would call some measurement process)
myf <- function (x1,x2) {
  x1 = x1/100
  x2 = x2/100
  return (x1 * exp(-x1*x1 - x2*x2))
}

# Compute f over all the requested points
requested$response = myf(requested$V1, requested$V2)

# Write results
write.table(requested, args[3], sep=" ", quote=F, col.names=F, row.names=F)

#!/usr/bin/env Rscript

args <- commandArgs(trailingOnly = T)
if (length(args) != 3) {
    stop("Usage: source <configuration.conf> <requested_file> <output_file>")
}

# Read the requested points
requested = read.table(args[2])

# Define the function we are studying
# (in a real experiment here we would call some measurement process)
#f <- function(x) { return (x**5*sin(x*10)) }
#f <- function(x) { return (x**3*sin(x*20)) }
f <- function(x) { return (x**5*abs(sin(x*2*pi*3))) }


# Compute f over all the requested points
requested$response = f(requested$V1)

# Write results
write.table(requested, args[3], sep=" ", quote=F, col.names=F, row.names=F)

# Copyright (c) 2011-2012, Universite de Versailles St-Quentin-en-Yvelines
#
# This file is part of ASK.  ASK is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Defines the conf function to help reading ASK configuration files from R
# modules.

require(RJSONIO, quietly=T)
configuration = fromJSON(paste(readLines(args[1]), collapse=""),
                         simplify=F)

conf <- function(key, default=NULL) {
  dollarkey = gsub("\\.","$", key)
  v = eval(parse(text=paste("configuration$",dollarkey,sep="")))
  if (is.null(v)) {
    if (is.null(default)) {
        stop(paste("Missing parameter ", key))
    } else {
        return(default)
    }
  } else {
    return(v)
  }
}

#!/bin/sh
# Copyright (c) 2011-2013, Universite de Versailles St-Quentin-en-Yvelines
#
# This file is part of ASK.  ASK is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Translate the latex documentation into google wiki format

DEST="./adaptive-sampling-kit.wiki/"
BUILD="./build/"

mkdir -p $DEST
mkdir -p $BUILD

for i in *.tex; do
    echo "Processing ${i}"
    bn=$(basename $i .tex)
    cp $i $BUILD/$bn.tmp
    sed -i -e 's/{| p{0.18\\textwidth} | p{0.18\\textwidth} | p{0.14\\textwidth} | p{0.50\\textwidth}  |}/{|c|c|c|l|}/g' $BUILD/$bn.tmp
    sed -i -e 's/\\hrefinternal{http:\/\/\/wiki\/\(.*\)}/\\href{http:\/\/\1}/g' $BUILD/$bn.tmp
    pandoc --from=latex -s $BUILD/$bn.tmp -o $BUILD/$bn.md
    sed -i -e 's/~~~~ {.\(.*\)}/<pre><code language="\1">/g' $BUILD/$bn.md
    sed -i -e 's/~~~~/<\/code><\/pre>/g' $BUILD/$bn.md
    ./latex2wiki/ttab.py $BUILD/$bn.md $BUILD/$bn.gtabs.md
    markowik --mx tables --image-baseurl "http://wiki.adaptive-sampling-kit.googlecode.com/git/" $BUILD/$bn.gtabs.md $BUILD/$bn.wiki.tmp
    sed -i -e 's/<pre><code/<code/g' $BUILD/$bn.wiki.tmp
    sed -i -e 's/<\/code><\/pre>/<\/code>/g' $BUILD/$bn.wiki.tmp
    ./latex2wiki/tlin.py $BUILD/$bn.wiki.tmp $DEST/$bn.wiki
done

./latex2wiki/autotoc.sh > $DEST/Sidebar.wiki

#!/bin/sh
# Copyright (c) 2011-2013, Universite de Versailles St-Quentin-en-Yvelines
#
# This file is part of ASK.  ASK is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Automatically generate a table of contents for google wiki format

DEST="./adaptive-sampling-kit.wiki/"
IFS="
"

echo "* [main Documentation]"
echo
for i in $DEST/Chapter*.wiki $DEST/fdl.wiki $DEST/ExperimentalData.wiki; do
    chapter_link=$(basename $i .wiki)
    chapter_name=$(egrep -Z '^= (.*) =' $i | sed 's/= //g' | sed 's/ =//g')
    toc=$(egrep -Z '^== (.*) ==' $i)
    echo "* [$chapter_link $chapter_name]"
    echo
    for s in $toc; do
        section_name=$(echo $s | sed 's/== //g' | sed 's/ ==//g')
        section_link=$(echo $section_name | sed 's/ /_/g')
        url="$chapter_name#$section_link"
        echo "  * [$chapter_link#$section_link $section_name]"
        echo
    done
done

=head1 Ask not what your user can do for you...

In many scripts, we need to prompt the end user for information - this
could be a prompt for a file name, a selection from a list of options,
or an answer to a yes/no question.

The traditional approach to this sort of question is to print your
question to STDOUT, read a line from STDIN, and apply some sort of
parsing to the answer...

   use 5.010;
   use strict;
   use warnings;
   
   my $answer;
   until (defined $answer) {
      print "Would you like fries with that?\n";
      $_ = <>;
      $answer = 1 if /^Y/i;
      $answer = 0 if /^N/i;
   }
   
   say "Adding fries!" if $answer;

One issue with this approach is: what happens when your script is not
running in a terminal?

One attempt at solving this problem is L<IO::Prompt::Tiny> and its ilk.
This performs a simple test to determine if the script is running on an
interactive terminal and only prompts the user if the terminal is
interactive. When the script is being run non-interactively (or if the
C<PERL_MM_USE_DEFAULT> environment variable is set), then it returns a
default answer instead.

   use 5.010;
   use strict;
   use warnings;
   use IO::Prompt::Tiny qw(prompt);
   
   my $answer;
   until (defined $answer) {
      # In non-interactive mode, assume they want no fries...
      $_ = prompt("Would you like fries with that?", "No");
      $answer = 1 if /^Y/i;
      $answer = 0 if /^N/i;
   }
   
   say "Adding fries!" if $answer;

The problem with this is that it makes the assumption that when the
terminal is non-interactive, there is absolutely no other way to prompt
the user, and you should be happy with the default answer. This is not
always a good assumption.

=head2 Opening up a dialogue

On some operating systems, double-clicking a Perl file will launch it
without a terminal. In these cases, you can probably interact with the
user by launching a dialog box. But how to do that? Doesn't that
require complex programming in L<Tk> or L<Wx> (modules which are not
in core, and not always straightforward to build)?

Enter L<Ask>. Ask abstracts away the details of interacting with your
user. It will do the terminal interaction test; it will check
C<PERL_MM_USE_DEFAULT>; it will see if the L<Wx>, L<Gtk2> or L<Tk>
modules are installed and usable; it will even use C</usr/bin/zenity>
(a GNOME component for adding GUI dialog boxes to shell scripts) if
it has to.

It will only resort to using the default answer if there's no other
possibility of interacting with the user. Here's our fast food worker
using Ask:

   use 5.010;
   use strict;
   use warnings;
   use Ask qw(question);
   
   my $answer = question("Would you like fries with that?", default => 0);
   say "Adding fries!" if $answer;

=head2 That is the question

In the previous example, we saw a yes-no question. How about something a
bit harder?

   use Ask qw( multiple_choice );
   
   my @answers = multiple_choice(
      "Please choose some pizza toppings...",
      choices => [
         [ sauce        => 'Our famous pizza sauce' ],
         [ cheese       => 'Oozing Mozzarella cheese' ],
         [ ham          => 'Finest Bavarian ham' ],
         [ pepperoni    => 'Spicy pepperoni' ],
         [ onion        => 'Onion slices' ],
         [ tinned_fruit => 'Chunky cuts of fresh pineapple' ],
      ],
   );
   say "Adding $_" for @answers;

Or if you just wish them to choose a single option from a list:

   use Ask qw( single_choice );
   
   my $existance = single_choice(
      "To be, or not to be; that is the question.",
      choices => [
         [ be     => "Be" ],
         [ not_be => "Don't be" ],
      ],
   );

Ask also has functions for file selection, text entry (including hidden
text - passwords) and displaying information, warnings and errors.

=head2 I object!

If you object to using the functional interface, you can get an object
using the C<< Ask->detect >> method and call C<question>,
C<single_choice> and friends as object methods.

   use 5.010;
   use strict;
   use warnings;
   use Ask;
   
   my $interface = Ask->detect;
   
   my $answer = $interface->question(
      text      => "Would you like fries with that?",
      default   => 0,
   );
   say "Adding fries!" if $answer;

The functional interface is just a friendly wrapper around Ask's
object-oriented core.

=head2 Boldly go

Let's say that you want to hook up your script to your drive-through
restaurant's voice recognition system. Ask's backends are all L<Moo>
classes performing the L<Ask::API> role. It's really easy to write your
own:

   package Ask::VoiceRecognition {
      
      use MyApp::Voice::Generator ();
      use MyApp::Voice::Recognition ();
      
      use Moo;
      with 'Ask::API';
      
      has generator => (
         is      => 'lazy',
         default => sub { MyApp::Voice::Generator->new },
      );
      
      has recognition => (
         is      => 'lazy',
         default => sub { MyApp::Voice::Recognition->new },
      );
      
      sub info {
         my $self = shift;
         my %args = @_;
         $self->generator->say($args{text});
      }
      
      sub entry {
         my $self = shift;
         my %args = @_;
         $self->info($args{text}) if exists $args{text};
         return $self->recognition->listen(seconds => 30);
      }
   }

That's all there is to it!

The Ask::API provides default implementations of C<question>,
C<file_selection>, C<multiple_choice>, etc, which you can override if
you choose to, but that is optional.

To force Ask to use your backend rather than the built-in ones, just set
the C<PERL_ASK_BACKEND> environment variable to the name of your module.

=head2 Ask the future

Ask is a young module and still needs some work. In particular:

=over

=item *

Detection of the best module for interacting with the user is naive.
It can end up selecting, say, Gtk2 on a headless Linux box.

=item *

A native Windows GUI backend is planned. The Gtk2, Wx and Tk backends
should all theoretically work on Windows, but rely on various library
files being present.

=back

Ask is L<on GitHub|https://github.com/tobyink/p5-ask> and
L<on Bitbucket|https://bitbucket.org/tobyink/p5-ask> so feel free to
contribute improvements!
